/*
Created		13/10/2008
Modified		20/07/2009
Project		
Model		
Company		
Author		
Version		
Database		mySQL 5 
*/


Create table `S4Q_E_PROCESS` (
	`id_process` Int NOT NULL AUTO_INCREMENT,
	`id_periodicity` Int,
	`name` Varchar(50) NOT NULL,
	`description` Varchar(255),
	`coordinator_class` Varchar(255),
	UNIQUE (`name`),
 Primary Key (`id_process`)) ENGINE = InnoDB;

Create table `S4Q_E_OPERATION` (
	`id_operation` Int NOT NULL AUTO_INCREMENT,
	`id_process` Int NOT NULL,
	`id_data_source` Int,
	`id_interface_type` Int,
	`name` Varchar(255) NOT NULL,
	`description` Varchar(255),
	`archive` Bool DEFAULT false,
	`rejected` Bool DEFAULT false,
 Primary Key (`id_operation`)) ENGINE = InnoDB;

Create table `S4Q_E_DATA_SOURCE` (
	`id_data_source` Int NOT NULL AUTO_INCREMENT,
	`id_source_type` Int NOT NULL,
	`name` Varchar(50) NOT NULL,
	`description` Varchar(255),
 Primary Key (`id_data_source`)) ENGINE = InnoDB;

Create table `S4Q_E_DATA_SOURCE_PARAMETER` (
	`id_data_source_parameter` Int NOT NULL AUTO_INCREMENT,
	`id_data_source` Int NOT NULL,
	`name` Varchar(255) NOT NULL,
	`value` Varchar(1000),
	`cript` Bool,
 Primary Key (`id_data_source_parameter`)) ENGINE = InnoDB;

Create table `S4Q_E_SOURCE_TYPE` (
	`id_source_type` Int NOT NULL AUTO_INCREMENT,
	`name` Varchar(50) NOT NULL,
	`description` Varchar(255),
	`extractor_class` Varchar(255),
	UNIQUE (`name`),
 Primary Key (`id_source_type`)) ENGINE = InnoDB;

Create table `S4Q_E_OPERATION_PARAMETER` (
	`id_operation_parameter` Int NOT NULL AUTO_INCREMENT,
	`id_operation` Int NOT NULL,
	`name` Varchar(255) NOT NULL,
	`value` Varchar(1000),
	`cript` Bool,
 Primary Key (`id_operation_parameter`)) ENGINE = InnoDB;

Create table `S4Q_E_OPERATION_FIELD` (
	`id_operation_field` Int NOT NULL AUTO_INCREMENT,
	`id_operation` Int NOT NULL,
	`id_interface_field` Int NOT NULL,
	`id_script` Int,
	`name` Varchar(255) NOT NULL,
 Primary Key (`id_operation_field`)) ENGINE = InnoDB;

Create table `S4Q_E_INTERFACE_FIELD` (
	`id_interface_field` Int NOT NULL AUTO_INCREMENT,
	`id_interface_type` Int NOT NULL,
	`name` Varchar(50),
	`field_type` Varchar(50),
	`sensible` Bool,
	`key_field` Bool,
 Primary Key (`id_interface_field`)) ENGINE = InnoDB;

Create table `S4Q_E_INTERFACE_TYPE` (
	`id_interface_type` Int NOT NULL AUTO_INCREMENT,
	`id_data_source` Int,
	`name` Varchar(50) NOT NULL,
	`description` Varchar(255),
	`tablename` Varchar(255),
	`filter_class` Varchar(255),
 Primary Key (`id_interface_type`)) ENGINE = InnoDB;

Create table `S4Q_E_DOMAIN_VALUE` (
	`id_field_value` Int NOT NULL AUTO_INCREMENT,
	`id_interface_field` Int NOT NULL,
	`value` Varchar(400),
 Primary Key (`id_field_value`)) ENGINE = InnoDB;

Create table `S4Q_E_SCRIPT` (
	`id_script` Int NOT NULL AUTO_INCREMENT,
	`name` Varchar(50) NOT NULL,
	`description` Varchar(1000),
	`script_type` Varchar(20),
	`script` Text,
 Primary Key (`id_script`)) ENGINE = InnoDB;

Create table `S4Q_LOG` (
	`id_log` Int NOT NULL AUTO_INCREMENT,
	`process_id` Int,
	`operation_id` Int,
	`extracted` Int,
	`inserted` Int,
	`operation_date` Datetime,
	`execution_date` Datetime,
	`archive_path` Varchar(1000),
	`completed` Bool DEFAULT false,
	`rejected` Int,
	`rejected_archive_path` Varchar(1000),
 Primary Key (`id_log`)) ENGINE = InnoDB;

Create table `S4Q_E_PERIODICITY` (
	`id_periodicity` Int NOT NULL AUTO_INCREMENT,
	`name` Varchar(50) NOT NULL,
	`description` Varchar(1000),
	`cronstring` Varchar(50) NOT NULL,
 Primary Key (`id_periodicity`)) ENGINE = InnoDB;


Alter table `S4Q_E_OPERATION` add unique `unipque_name_process` (`id_process`,`name`);
Alter table `S4Q_E_DATA_SOURCE` add unique `unique_name_source_type` (`id_data_source`,`name`);
Alter table `S4Q_E_INTERFACE_FIELD` add unique `unipque_name_interface_type` (`id_interface_type`,`name`);
Alter table `S4Q_E_SCRIPT` add unique `unique_name` (`name`);

Create UNIQUE Index `e_process_name_uk` ON `S4Q_E_PROCESS` (`name`);
Create UNIQUE Index `e_source_type_name_uk` ON `S4Q_E_SOURCE_TYPE` (`name`);
Create UNIQUE Index `e_interface_name_uk` ON `S4Q_E_INTERFACE_TYPE` (`name`);


Alter table `S4Q_E_OPERATION` add Foreign Key (`id_process`) references `S4Q_E_PROCESS` (`id_process`) on delete no action on update no action;
Alter table `S4Q_E_OPERATION_FIELD` add Foreign Key (`id_operation`) references `S4Q_E_OPERATION` (`id_operation`) on delete  restrict on update  restrict;
Alter table `S4Q_E_OPERATION_PARAMETER` add Foreign Key (`id_operation`) references `S4Q_E_OPERATION` (`id_operation`) on delete  restrict on update  restrict;
Alter table `S4Q_E_DATA_SOURCE_PARAMETER` add Foreign Key (`id_data_source`) references `S4Q_E_DATA_SOURCE` (`id_data_source`) on delete no action on update no action;
Alter table `S4Q_E_OPERATION` add Foreign Key (`id_data_source`) references `S4Q_E_DATA_SOURCE` (`id_data_source`) on delete no action on update no action;
Alter table `S4Q_E_DATA_SOURCE` add Foreign Key (`id_source_type`) references `S4Q_E_SOURCE_TYPE` (`id_source_type`) on delete no action on update no action;
Alter table `S4Q_E_OPERATION_FIELD` add Foreign Key (`id_interface_field`) references `S4Q_E_INTERFACE_FIELD` (`id_interface_field`) on delete no action on update no action;
Alter table `S4Q_E_DOMAIN_VALUE` add Foreign Key (`id_interface_field`) references `S4Q_E_INTERFACE_FIELD` (`id_interface_field`) on delete  restrict on update  restrict;
Alter table `S4Q_E_INTERFACE_FIELD` add Foreign Key (`id_interface_type`) references `S4Q_E_INTERFACE_TYPE` (`id_interface_type`) on delete no action on update no action;
Alter table `S4Q_E_OPERATION` add Foreign Key (`id_interface_type`) references `S4Q_E_INTERFACE_TYPE` (`id_interface_type`) on delete no action on update no action;
Alter table `S4Q_E_OPERATION_FIELD` add Foreign Key (`id_script`) references `S4Q_E_SCRIPT` (`id_script`) on delete  restrict on update  restrict;
Alter table `S4Q_E_PROCESS` add Foreign Key (`id_periodicity`) references `S4Q_E_PERIODICITY` (`id_periodicity`) on delete  restrict on update  restrict;
Alter table `S4Q_E_INTERFACE_TYPE` add Foreign Key (`id_data_source`) references `SBI_DATA_SOURCE` (`DS_ID`) on delete  restrict on update  restrict;


INSERT INTO SBI_DOMAINS (VALUE_CD, VALUE_NM, DOMAIN_CD, DOMAIN_NM, VALUE_DS)
VALUES('S4QADMIN', 'sbidomains.nm.s4qadmin', 'ROLE_TYPE', 'Role type', 'sbidomains.ds.s4qadmin');

#INSERT INTO SBI_EXT_ROLES (NAME, DESCR, CODE, ROLE_TYPE_CD, ROLE_TYPE_ID) VALUES ('/spagobi/s4qadmin', '/spagobi/s4qadmin', '', 'S4QADMIN',
#(SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'));

INSERT INTO SBI_USER_FUNC (NAME, DESCRIPTION) VALUES ('ExtractionManagement','ExtractionManagement');

INSERT INTO SBI_ROLE_TYPE_USER_FUNC (ROLE_TYPE_ID, USER_FUNCT_ID) VALUES
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'EnginesManagement' AND DESCRIPTION = 'EnginesManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'FunctionalitiesManagement' AND DESCRIPTION = 'FunctionalitiesManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'LovsManagement' AND DESCRIPTION = 'LovsManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'ConstraintManagement' AND DESCRIPTION = 'ConstraintManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'ParameterManagement' AND DESCRIPTION = 'ParameterManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'DocumentAdministration' AND DESCRIPTION = 'DocumentAdministration')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'DocumentDevManagement' AND DESCRIPTION = 'DocumentDevManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'DocumentTestManagement' AND DESCRIPTION = 'DocumentTestManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'DocumentAdminManagement' AND DESCRIPTION = 'DocumentAdminManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'ImportExportManagement' AND DESCRIPTION = 'ImportExportManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'SchedulerManagement' AND DESCRIPTION = 'SchedulerManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'WorkspaceManagement' AND DESCRIPTION = 'WorkspaceManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'DocumentManagement' AND DESCRIPTION = 'DocumentManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'SyncronizeRolesManagement' AND DESCRIPTION = 'SyncronizeRolesManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'ProfileAttributeManagement' AND DESCRIPTION = 'ProfileAttributeManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'DataSourceManagement' AND DESCRIPTION = 'DataSourceManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'DocumentDeleteManagement' AND DESCRIPTION = 'DocumentDeleteManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'DocumentStateManagement' AND DESCRIPTION = 'DocumentStateManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'DocumentDetailManagement' AND DESCRIPTION = 'DocumentDetailManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'ViewMyFolderAdmin' AND DESCRIPTION = 'ViewMyFolderAdmin')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'DocumentMetadataManagement' AND DESCRIPTION = 'DocumentMetadataManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'LovsView' AND DESCRIPTION = 'LovsView')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'ConstraintView' AND DESCRIPTION = 'ConstraintView')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'ParameterView' AND DESCRIPTION = 'ParameterView')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'DatasetManagement' AND DESCRIPTION = 'DatasetManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'DocumentMoveDownState' AND DESCRIPTION = 'DocumentMoveDownState')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'DocumentMoveUpState' AND DESCRIPTION = 'DocumentMoveUpState')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'ModifyRefresh' AND DESCRIPTION = 'ModifyRefresh')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'MenuManagement' AND DESCRIPTION = 'MenuManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'KpiManagement' AND DESCRIPTION = 'KpiManagement')),
((SELECT VALUE_ID FROM SBI_DOMAINS WHERE DOMAIN_CD = 'ROLE_TYPE' AND VALUE_CD = 'S4QADMIN'), (SELECT USER_FUNCT_ID FROM SBI_USER_FUNC WHERE NAME = 'ExtractionManagement' AND DESCRIPTION = 'ExtractionManagement'));
INSERT INTO S4Q_E_PERIODICITY (name, description, cronstring) VALUES 
('every day', 'Fire at midnight every day ','0 0 0 * * ?'),
('every monday', 'Fire every monday at midnight','0 0 0 ? * MON'),
('every month', 'Fire the 1st day of every month at midnight','0 0 0 1 * ?'); 